'**********************************************************************************
' $Archive:  $ 
' $Author:  $ 
' $Date:  $  $Revision:  $
'  Description : 
' *********************************************************************************
Imports System.Xml

Public Class WeatherControl
    Inherits System.Web.UI.UserControl

    Protected WithEvents RepeaterWeather As System.Web.UI.WebControls.DataList
    Protected WithEvents LabelWeatherXML As System.Web.UI.WebControls.Label
    Protected WithEvents LabelDate As System.Web.UI.WebControls.Label
    Protected WithEvents LabelTempMax As System.Web.UI.WebControls.Label
    Protected WithEvents LabelTempMin As System.Web.UI.WebControls.Label
    Protected WithEvents LabelHumidite As System.Web.UI.WebControls.Label
    Protected WithEvents ImageTempMeteoJour As System.Web.UI.WebControls.Image
    Protected WithEvents ImageTempMeteoNuit As System.Web.UI.WebControls.Image

#Region " Code gnr par le Concepteur Web Form "

    'Cet appel est requis par le Concepteur Web Form.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub

    'REMARQUE: la dclaration d'espace rserv suivante est requise par le Concepteur Web Form.
    'Ne pas supprimer ou dplacer.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: cet appel de mthode est requis par le Concepteur Web Form
        'Ne le modifiez pas en utilisant l'diteur de code.
        InitializeComponent()
    End Sub

#End Region

    ' -----------------------------------------------------
    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ChargeCadreMeteo(CodeVilleMeteo, NombreJoursMeteo)

    End Sub

    ' -----------------------------------------------------
    Private Sub ChargeCadreMeteo(ByVal CodeVille As String, ByVal nbjours As Integer)
        Dim URLWeather As String = URLWeatherBase & CodeVille & "?cc=*&unit=s&dayf=" & nbjours & "&prod=xoap&par=" & PartnerID & "&key=" & LicenseKey
        Dim Marow As DataRow
        Dim myXmlURLreader As XmlTextReader
        Dim myXmlDocument As XmlDocument = New XmlDocument
        Dim objAttr As XmlAttribute
        Dim objRootNode As XmlNode
        Dim objChildNode As XmlNode
        Dim objSubChildNode As XmlNode
        Dim objChildNodeJourMeteo As XmlNode
        Dim objChildNodeJourMeteoJournee As XmlNode
        Dim Aujourdhui As DateTime = Date.Now
        Dim DateDuJour As String()
        Dim Jour As String = String.Empty
        Dim NumeroJour As Integer = 0
        Dim RetourDate As New DateTime
        Dim TableMeteo As New DataTable
        Dim dr As DataRow
        Try
            PrepareDatatables(TableMeteo)
            ' Load the XmlTextReader from the URL
            myXmlURLreader = New XmlTextReader(URLWeather)
            myXmlDocument.Load(myXmlURLreader)
            'Rcupration du noeud racine
            objRootNode = myXmlDocument.DocumentElement
            'Rcupration du premier noeud enfant
            objChildNode = objRootNode.FirstChild
            ' Parcourt l'ensemble des noeuds (de type lments) et affiche leur contenue texte
            While Not (objChildNode Is Nothing)
                If objChildNode.Name.ToLower.Trim = "dayf" Then
                    objSubChildNode = objChildNode.FirstChild
                    While Not (objSubChildNode Is Nothing)
                        If objSubChildNode.Name.ToLower.Trim = "day" Then
                            dr = TableMeteo.NewRow()
                            If Not (objSubChildNode.Attributes Is Nothing) AndAlso objSubChildNode.Attributes.Count > 0 Then
                                ' Parcourt l'ensemble des attributs du noeud courant
                                For Each objAttr In objSubChildNode.Attributes
                                    'et affiche leur contenue texte
                                    If objAttr.Name = "dt" Then
                                        DateDuJour = objAttr.Value.Split(" ")
                                    ElseIf objAttr.Name = "t" Then
                                        Jour = objAttr.Value
                                    ElseIf objAttr.Name = "d" Then
                                        NumeroJour = objAttr.Value
                                    End If
                                Next
                                RetourDate = Aujourdhui.AddDays(NumeroJour)
                                Jour = TransformeMotJourUS_FR(Jour) & " " & DateDuJour(1) & " " & TransformeMotMoisUS_FR(DateDuJour(0)) & " " & RetourDate.Year
                            End If
                            dr("DATEJOUR") = Jour
                            objChildNodeJourMeteo = objSubChildNode.FirstChild
                            While Not (objChildNodeJourMeteo Is Nothing)
                                Select Case objChildNodeJourMeteo.Name.ToLower.Trim
                                    Case "hi"
                                        dr("TEMP_MAX") = ConversionTemperature(objChildNodeJourMeteo.InnerText)
                                    Case "low"
                                        dr("TEMP_MIN") = ConversionTemperature(objChildNodeJourMeteo.InnerText)
                                    Case "part"
                                        objAttr = objChildNodeJourMeteo.Attributes.Item(0)
                                        If objAttr.Value = "d" Then
                                            objChildNodeJourMeteoJournee = objChildNodeJourMeteo.FirstChild
                                            While Not (objChildNodeJourMeteoJournee Is Nothing)
                                                Select Case objChildNodeJourMeteoJournee.Name.ToLower.Trim
                                                    Case "icon"
                                                        dr("CODE_IMAGE_JOUR") = objChildNodeJourMeteoJournee.InnerText
                                                    Case "t"
                                                        dr("LIBELLEJOUR") = objChildNodeJourMeteoJournee.InnerText
                                                    Case "hmid"
                                                        dr("HUMIDITE") = objChildNodeJourMeteoJournee.InnerText
                                                    Case "ppcp"
                                                        dr("PRECIPITATION") = objChildNodeJourMeteoJournee.InnerText
                                                End Select
                                                objChildNodeJourMeteoJournee = objChildNodeJourMeteoJournee.NextSibling
                                            End While
                                        ElseIf objAttr.Value = "n" Then
                                            objChildNodeJourMeteoJournee = objChildNodeJourMeteo.FirstChild
                                            While Not (objChildNodeJourMeteoJournee Is Nothing)
                                                Select Case objChildNodeJourMeteoJournee.Name.ToLower.Trim
                                                    Case "icon"
                                                        dr("CODE_IMAGE_NUIT") = objChildNodeJourMeteoJournee.InnerText
                                                    Case "t"
                                                        dr("LIBELLENUIT") = objChildNodeJourMeteoJournee.InnerText
                                                End Select
                                                objChildNodeJourMeteoJournee = objChildNodeJourMeteoJournee.NextSibling
                                            End While

                                        End If
                                End Select
                                objChildNodeJourMeteo = objChildNodeJourMeteo.NextSibling
                            End While
                            TableMeteo.Rows.Add(dr)
                        End If
                        objSubChildNode = objSubChildNode.NextSibling
                    End While
                End If
                objChildNode = objChildNode.NextSibling
            End While
            RepeaterWeather.DataSource = TableMeteo
            RepeaterWeather.DataBind()
        Catch ex As Exception
            LabelWeatherXML.Visible = True
            LabelWeatherXML.Text &= "Chargement du document XML impossible.<br>Exception : " & ex.Message
        Finally
            TableMeteo.Dispose()
            myXmlURLreader = Nothing
        End Try
    End Sub

    ' -----------------------------------------------------
    Private Sub RepeaterWeather_ItemCreated(ByVal sender As Object, ByVal e As System.Web.UI.WebControls.DataListItemEventArgs) Handles RepeaterWeather.ItemCreated
        'Evnement dclanch pour chaque cration d'item dans le DataRepeater

        'pour chaque item du repeater
        If e.Item.ItemType = ListItemType.Item Or e.Item.ItemType = ListItemType.AlternatingItem Then
            With CType(e.Item.FindControl("LabelDate"), WebControls.Label)
                .Text = e.Item.DataItem("DATEJOUR")
            End With

            With CType(e.Item.FindControl("LabelTempMax"), WebControls.Label)
                .Text = e.Item.DataItem("TEMP_MAX")
            End With

            With CType(e.Item.FindControl("LabelTempMin"), WebControls.Label)
                .Text = e.Item.DataItem("TEMP_MIN")
            End With

            With CType(e.Item.FindControl("LabelHumidite"), WebControls.Label)
                .Text = e.Item.DataItem("HUMIDITE")
            End With

            With CType(e.Item.FindControl("ImageTempMeteoJour"), WebControls.Image)
                'Url de l'image
                .ImageUrl = "./WeatherIncons/" & (e.Item.DataItem("CODE_IMAGE_JOUR")) & ".png"
                .AlternateText = e.Item.DataItem("LIBELLEJOUR")
            End With
            With CType(e.Item.FindControl("ImageTempMeteoNuit"), WebControls.Image)
                'Url de l'image
                .ImageUrl = "./WeatherIncons/" & (e.Item.DataItem("CODE_IMAGE_NUIT")) & ".png"
                .AlternateText = e.Item.DataItem("LIBELLENUIT")
            End With
        End If
    End Sub

    ' -----------------------------------------------------
    Private Sub PrepareDatatables(ByRef LaTablePrepare As DataTable)
        Dim myColumn As DataColumn = New DataColumn

        myColumn.DataType = System.Type.GetType("System.String")
        myColumn.Caption = "CODE_IMAGE_JOUR"
        myColumn.ColumnName = "CODE_IMAGE_JOUR"
        LaTablePrepare.Columns.Add(myColumn)

        myColumn = New DataColumn
        myColumn.DataType = System.Type.GetType("System.String")
        myColumn.Caption = "CODE_IMAGE_NUIT"
        myColumn.ColumnName = "CODE_IMAGE_NUIT"
        LaTablePrepare.Columns.Add(myColumn)

        myColumn = New DataColumn
        myColumn.DataType = System.Type.GetType("System.String")
        myColumn.Caption = "TEMP_MAX"
        myColumn.ColumnName = "TEMP_MAX"
        LaTablePrepare.Columns.Add(myColumn)

        myColumn = New DataColumn
        myColumn.DataType = System.Type.GetType("System.String")
        myColumn.Caption = "TEMP_MIN"
        myColumn.ColumnName = "TEMP_MIN"
        LaTablePrepare.Columns.Add(myColumn)

        myColumn = New DataColumn
        myColumn.DataType = System.Type.GetType("System.String")
        myColumn.Caption = "HUMIDITE"
        myColumn.ColumnName = "HUMIDITE"
        LaTablePrepare.Columns.Add(myColumn)

        myColumn = New DataColumn
        myColumn.DataType = System.Type.GetType("System.String")
        myColumn.Caption = "PRECIPITATION"
        myColumn.ColumnName = "PRECIPITATION"
        LaTablePrepare.Columns.Add(myColumn)

        myColumn = New DataColumn
        myColumn.DataType = System.Type.GetType("System.String")
        myColumn.Caption = "DATEJOUR"
        myColumn.ColumnName = "DATEJOUR"
        LaTablePrepare.Columns.Add(myColumn)

        myColumn = New DataColumn
        myColumn.DataType = System.Type.GetType("System.String")
        myColumn.Caption = "LIBELLEJOUR"
        myColumn.ColumnName = "LIBELLEJOUR"
        LaTablePrepare.Columns.Add(myColumn)

        myColumn = New DataColumn
        myColumn.DataType = System.Type.GetType("System.String")
        myColumn.Caption = "LIBELLENUIT"
        myColumn.ColumnName = "LIBELLENUIT"
        LaTablePrepare.Columns.Add(myColumn)

        myColumn.Dispose()
    End Sub

    ' -----------------------------------------------------
    Public Function TransformeMotMoisUS_FR(ByVal Chaine As String) As String
        Select Case Chaine.ToLower
            Case "jan"
                Return "Janvier"
            Case "feb"
                Return "Fvrier"
            Case "mar"
                Return "Mars"
            Case "apr"
                Return "Avril"
            Case "may"
                Return "Mai"
            Case "jun"
                Return "Juin"
            Case "jul"
                Return "Juillet"
            Case "aug"
                Return "Aout"
            Case "sep"
                Return "Septembre"
            Case "oct"
                Return "Octobre"
            Case "nov"
                Return "Novembre"
            Case "dec"
                Return "Dcembre"
        End Select
    End Function

    ' -----------------------------------------------------
    Public Function ConversionTemperature(ByVal Farenheit As String) As String
        'Conversion de degrs Farenheit en degrs Celsius selon C = (F-32)/9*5
        Try
            Return Math.Round(((CType(Farenheit, Integer) - 32) / 9 * 5), 0) & "C"
        Catch ex As Exception
            Return Farenheit
        End Try
    End Function

    ' -----------------------------------------------------
    Public Function TransformeMotJourUS_FR(ByVal Chaine As String) As String
        Select Case Chaine.ToLower
            Case "monday"
                Return "Lundi"
            Case "tuesday"
                Return "Mardi"
            Case "wednesday"
                Return "Mercredi"
            Case "thursday"
                Return "Jeudi"
            Case "friday"
                Return "Vendredi"
            Case "saturday"
                Return "Samedi"
            Case "sunday"
                Return "Dimanche"
        End Select
    End Function

    ' -----------------------------------------------------
    Public ReadOnly CodeVilleMeteo As String = Trim(ConfigurationSettings.AppSettings("CodeVilleMeteo"))
    Public ReadOnly NombreJoursMeteo As String = Trim(ConfigurationSettings.AppSettings("NombreJoursMeteo"))
    Public ReadOnly PartnerID As String = Trim(ConfigurationSettings.AppSettings("PartnerID"))
    Public ReadOnly LicenseKey As String = Trim(ConfigurationSettings.AppSettings("LicenseKey"))
    Public ReadOnly URLWeatherBase As String = Trim(ConfigurationSettings.AppSettings("URLWeatherBase"))

    ' -----------------------------------------------------
End Class
